package com.s3ai.corporate_app2.controllers.rest.json

import com.s3ai.corporate_app2.Cinema
import com.s3ai.corporate_app2.CinemaService
import com.s3ai.corporate_app2.controllers.getInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.MediaType
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController
import java.util.*
import javax.servlet.http.HttpServletResponse

@RestController
@RequestMapping("/api/json/cinemas/")
class CinemasJsonController {
    @Autowired
    lateinit var cinemaService: CinemaService

    @GetMapping("/all", produces = [MediaType.APPLICATION_JSON_VALUE])
    fun getCinemas(response: HttpServletResponse): MutableList<Cinema> {
        return cinemaService.findAll()
    }

    @GetMapping("/item/{id}", produces = [MediaType.APPLICATION_JSON_VALUE])
    fun getCinema(@PathVariable id: UUID, response: HttpServletResponse): Cinema? {
        return getInstance(id, cinemaService, response)
    }

}