package com.s3ai.corporate_app2.controllers.rest.xml

import com.s3ai.corporate_app2.Ticket
import com.s3ai.corporate_app2.TicketService
import com.s3ai.corporate_app2.controllers.getInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.MediaType
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController
import java.util.*
import javax.servlet.http.HttpServletResponse

@RestController
@RequestMapping("/api/xml/tickets/")
class TicketsXmlController {
    @Autowired
    lateinit var ticketService: TicketService

    @GetMapping("/all", produces = [MediaType.APPLICATION_XML_VALUE])
    fun getTickets(response: HttpServletResponse): MutableList<Ticket> {
        return ticketService.findAll()
    }

    @GetMapping("/item/{id}", produces = [MediaType.APPLICATION_XML_VALUE])
    fun getTicket(@PathVariable id: UUID, response: HttpServletResponse): Ticket? {
        return getInstance(id, ticketService, response)
    }
}