package com.s3ai.corporate_app2.controllers.rest.xml

import com.s3ai.corporate_app2.User
import com.s3ai.corporate_app2.UserService
import com.s3ai.corporate_app2.controllers.getInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.MediaType
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController
import java.util.*
import javax.servlet.http.HttpServletResponse

@RestController
@RequestMapping("/api/xml/users/")
class UsersXmlController {
    @Autowired
    lateinit var userService: UserService

    @GetMapping("/all", produces = [MediaType.APPLICATION_XML_VALUE])
    fun getUsers(response: HttpServletResponse): MutableList<User> {
        return userService.findAll()
    }

    @GetMapping("/item/{id}", produces = [MediaType.APPLICATION_XML_VALUE])
    fun getUser(@PathVariable id: UUID, response: HttpServletResponse): User? {
        return getInstance(id, userService, response)
    }
}