package com.s3ai.corporate_app2.controllers.rest.xslt

import com.s3ai.corporate_app2.TicketService
import com.s3ai.corporate_app2.controllers.XMLTransform
import com.s3ai.corporate_app2.controllers.getXSLTransformedInstance
import org.springframework.beans.factory.annotation.Autowired
import org.springframework.http.MediaType
import org.springframework.web.bind.annotation.GetMapping
import org.springframework.web.bind.annotation.PathVariable
import org.springframework.web.bind.annotation.RequestMapping
import org.springframework.web.bind.annotation.RestController
import java.util.*
import javax.servlet.http.HttpServletResponse

@RestController
@RequestMapping("/api/xslt/tickets/")
class TicketsXsltController {
    @Autowired
    lateinit var ticketService: TicketService

    val xsltResourceName: String = "ticket-process.xslt"

    @GetMapping("/all", produces = [MediaType.TEXT_HTML_VALUE])
    fun getCinemas(response: HttpServletResponse): String {
        return XMLTransform(ticketService.findAll(), xsltResourceName)
    }


    @GetMapping("/item/{id}", produces = [MediaType.TEXT_HTML_VALUE])
    fun getCinema(@PathVariable id: UUID, response: HttpServletResponse): String? {
        return getXSLTransformedInstance(id, ticketService, xsltResourceName, response)
    }
}