package com.s3ai.corporate_app2

import org.springframework.stereotype.Service
import java.util.*


interface CinemaServices<T> {
    fun findAll(): MutableList<T>
    fun findById(id: UUID): T?
    fun save(item: T): T
    fun delete(item: T)
}

@Service
class CinemaService(private val cinemaRepository: CinemaRepository) : CinemaServices<Cinema> {
    override fun findAll(): MutableList<Cinema> = cinemaRepository.findAll()
    override fun findById(id: UUID): Cinema? = cinemaRepository.findById(id).orElse(null)
    override fun save(item: Cinema): Cinema = cinemaRepository.save(item)
    override fun delete(item: Cinema) = cinemaRepository.delete(item)
}

@Service
class UserService(private val userRepository: UserRepository) : CinemaServices<User> {
    override fun findAll(): MutableList<User> = userRepository.findAll()
    override fun findById(id: UUID): User? = userRepository.findById(id).orElse(null)
    override fun save(item: User): User = userRepository.save(item)
    override fun delete(item: User) = userRepository.delete(item)
}

@Service
class TicketService(private val ticketRepository: TicketRepository) : CinemaServices<Ticket> {
    override fun findAll(): MutableList<Ticket> = ticketRepository.findAll()
    override fun findById(id: UUID): Ticket? = ticketRepository.findById(id).orElse(null)
    override fun save(item: Ticket): Ticket = ticketRepository.save(item)
    override fun delete(item: Ticket) = ticketRepository.delete(item)
}